require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module AccessRole
      # @deprecated Use {UU::OS::PersonalAccessRole::PersonalAccessRoleSetAttributes} instead.
      class AccessRoleSetAttributes < UU::OS::REST::DTO

        # @see AccessRole#set_attributes
        attr_accessor :first_name

        # @see AccessRole#set_attributes
        attr_accessor :surname

        # @see AccessRole#set_attributes
        attr_accessor :code

        # @see AccessRole#set_attributes
        attr_accessor :description

        # @see AccessRole#set_attributes
        attr_accessor :security_level

        # @see AccessRole#set_attributes
        attr_accessor :security_clearance

        # @see AccessRole#set_attributes
        attr_accessor :searchable_in_territory

        # @see AccessRole#set_attributes
        attr_accessor :icon_uri

        # @deprecated All From OU will not be used in the new authorization (v4).
        attr_accessor :grant_all_from_organizational_unit

        # Indicates whether the primarily displayed content of the access role is component content.
        attr_accessor :component_content
        
        def first_name
          attributes[:firstName]
        end

        def first_name=(val)
          attributes[:firstName] = val
        end

        def surname
          attributes[:surname]
        end

        def surname=(val)
          attributes[:surname] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def security_clearance
          attributes[:securityClearance]
        end

        def security_clearance=(val)
          attributes[:securityClearance] = val
        end

        def searchable_in_territory
          attributes[:searchableInTerritory]
        end

        def searchable_in_territory=(val)
          attributes[:searchableInTerritory] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        # @deprecated All From OU will not be used in the new authorization (v4).
        def grant_all_from_organizational_unit
          attributes[:grantAllFromOrganizationalUnit]
        end

        # @deprecated All From OU will not be used in the new authorization (v4).
        def grant_all_from_organizational_unit=(val)
          attributes[:grantAllFromOrganizationalUnit] = val
        end

        def component_content
          attributes[:componentContent]
        end
                
        def component_content=(val)
          attributes[:componentContent] = val
        end
        
      end
    end

  end

end
