require 'uu/os/rest/dto'
require 'uu/os/uesuri'


# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Activity Action.
    module ActivityAction
      # @see ActivityAction#create
      class ActivityActionCreate < UU::OS::REST::DTO

        # @see ActivityAction#create
        attr_accessor :code

        # @see ActivityAction#create
        attr_accessor :type

        # @see ActivityAction#create
        attr_accessor :activity_state_template_uri

        # @see ActivityAction#create
        attr_accessor :target_artifact_state_template_uri

        # @see ActivityAction#create
        attr_accessor :target_activity_state_template_uri

        # @see ActivityAction#create
        attr_accessor :macro_uri

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def type
          attributes[:type]
        end

        def type=(val)
          attributes[:type] = val
        end

        def activity_state_template_uri
          attributes[:activityStateTemplateUri]
        end

        def activity_state_template_uri=(val)
          if val
            attributes[:activityStateTemplateUri] = UU::OS::UESURI.new(val)
          else
            attributes[:activityStateTemplateUri] = nil
          end
        end

        def target_artifact_state_template_uri
          attributes[:targetArtifactStateTemplateUri]
        end

        def target_artifact_state_template_uri=(val)
          if val
            attributes[:targetArtifactStateTemplateUri] = UU::OS::UESURI.new(val)
          else
            attributes[:targetArtifactStateTemplateUri] = nil
          end
        end

        def target_activity_state_template_uri
          attributes[:targetActivityStateTemplateUri]
        end

        def target_activity_state_template_uri=(val)
          if val
            attributes[:targetActivityStateTemplateUri] = UU::OS::UESURI.new(val)
          else
            attributes[:targetActivityStateTemplateUri] = nil
          end
        end

        def macro_uri
          attributes[:macroUri]
        end

        def macro_uri=(val)
          if val
            attributes[:macroUri] = UU::OS::UESURI.new(val)
          else
            attributes[:macroUri] = nil
          end
        end

      end
    end

  end
end
