require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Cast.
    module Cast
      # @see Cast#exists
      class CastExists < UU::OS::REST::DTO

        # @see Cast#exists
        attr_accessor :casted_subject_uri

        # @see Cast#exists
        attr_accessor :casted_subject_universe_id

        # @see Cast#exists
        attr_accessor :recursive
        def casted_subject_uri
          attributes[:castedSubjectUri]
        end

        def casted_subject_uri=(val)
          if val
            attributes[:castedSubjectUri] = UU::OS::UESURI.new(val)
          else
            attributes[:castedSubjectUri] = nil
          end
        end

        def casted_subject_universe_id
          attributes[:castedSubjectUniverseId]
        end

        def casted_subject_universe_id=(val)
          if val
            attributes[:castedSubjectUniverseId] = val
          else
            attributes[:castedSubjectUniverseId] = nil
          end
        end

        def recursive
          attributes[:recursive]
        end

        def recursive=(val)
          attributes[:recursive] = val
        end

      end
    end

  end

end
