require 'uu/os/rest/dto'
require 'uu/os/uesuri'


module UU
  module OS

    module Friend
      class FriendCreate < UU::OS::REST::DTO

        # @see Friend#create
        attr_accessor :meta_artifact_uri

        # @see Friend#create
        attr_accessor :universe_id

        # @see Friend#create
        attr_accessor :first_name

        # @see Friend#create
        attr_accessor :surname

        # @see Friend#create
        attr_accessor :code

        # @see Friend#create
        attr_accessor :description

        # @see Friend#create
        attr_accessor :security_level

        # @see Friend#create
        attr_accessor :icon_uri

        # @see Friend#create
        attr_accessor :message



        def meta_artifact_uri
          attributes[:metaArtifactUri]
        end

        def meta_artifact_uri=(val)
          if val
            attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:metaArtifactUri] = nil
          end
        end

        def universe_id
          attributes[:universeId]
        end

        def universe_id=(val)
          attributes[:universeId] = val
        end

        def first_name
          attributes[:firstName]
        end

        def first_name=(val)
          attributes[:firstName] = val
        end

        def middle_name
          attributes[:middleName]
        end

        def middle_name=(val)
          attributes[:middleName] = val
        end

        def surname
          attributes[:surname]
        end

        def surname=(val)
          attributes[:surname] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def message
          attributes[:message]
        end

        def message=(val)
          attributes[:message] = val
        end

      end
    end

  end
end
