require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module MetaArtifact
      # @see MetaArtifact#set_default_presentation_attributes
      class MetaArtifactSetDefaultPresentationAttributes < UU::OS::REST::DTO

        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :artifact_width

        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :header_display_mode

        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :control_bar_display_mode

        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :comment_display_mode

        # @deprecated Use {#artifact_display_mode} instead.
        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :context_menu_display_mode

        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :artifact_display_mode

        # @deprecated Use {#lock_personal_settings} and {#lock_artifact_settings} instead.
        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :lock_settings
        
        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :lock_personal_settings
        
        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :lock_artifact_settings

        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :visual_style

        # @see MetaArtifact#set_default_presentation_attributes
        attr_accessor :navigation_area_display_mode
        def artifact_width
          attributes[:artifactWidth]
        end

        def  artifact_width=(val)
          attributes[:artifactWidth] = val
        end

        def header_display_mode
          attributes[:headerDisplayMode]
        end

        def header_display_mode=(val)
          attributes[:headerDisplayMode] = val
        end

        def control_bar_display_mode
          attributes[:controlBarDisplayMode]
        end

        def control_bar_display_mode=(val)
          attributes[:controlBarDisplayMode] = val
        end

        def comment_display_mode
          attributes[:commentDisplayMode]
        end

        def comment_display_mode=(val)
          attributes[:commentDisplayMode] = val
        end

        # @deprecated
        def context_menu_display_mode
          attributes[:contextMenuDisplayMode]
        end

        # @deprecated
        def context_menu_display_mode=(val)
          attributes[:contextMenuDisplayMode] = val
        end

        def artifact_display_mode
          attributes[:artifactDisplayMode]
        end

        def artifact_display_mode=(val)
          attributes[:artifactDisplayMode] = val
        end

        def lock_settings
          attributes[:lockSettings]
        end

        def lock_settings=(val)
          attributes[:lockSettings] = val
        end
        
        def lock_personal_settings
          attributes[:lockPersonalSettings]
        end

        def lock_personal_settings=(val)
          attributes[:lockPersonalSettings] = val
        end
        
        def lock_artifact_settings
          attributes[:lockArtifactSettings]
        end

        def lock_artifact_settings=(val)
          attributes[:lockArtifactSettings] = val
        end

        def visual_style
          attributes[:visualStyle]
        end

        def visual_style=(val)
          attributes[:visualStyle] = val
        end

        def navigation_area_display_mode
          attributes[:navigationAreaDisplayMode]
        end

        def navigation_area_display_mode=(val)
          attributes[:navigationAreaDisplayMode] = val
        end

      end
    end
  end
end
