require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Role Interface.
    module RoleInterface
      # @see RoleInterface#get_role_list
      class RoleInterfaceGetRoleListItem < UU::OS::REST::DTO

        # URI of the role with the connected interface. Not nil.
        attr_accessor :uri

        # The name of the role.
        attr_accessor :name

        # Code of the role. Not nil.
        attr_accessor :code

        # UESURI of the entity type of the role. Not nil.
        attr_accessor :entity_type_uri

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def entity_type_uri 
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val) 
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end
  end
end