require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module RoleSearch
      class RoleSearchResultItem < UU::OS::REST::DTO

        # The code of the role.
        attr_accessor :code

        # The icon of the role (as stored in the code table).
        attr_accessor :icon

        # The name of the container that this role is in.
        attr_accessor :location_name

        # The UES-URI of the container that this role is in.
        attr_accessor :location_uri

        # The name of the role.
        attr_accessor :name

        # The name of the OU that this role is in.
        attr_accessor :organizational_unit_name

        # The UES-URI of the OU that this role is in.
        attr_accessor :organizational_unit_uri

        # The state icon of the role (as stored in the code table).
        attr_accessor :state_icon

        # The state type of the role.
        attr_accessor :state_type

        # The UES-URI of the role.
        attr_accessor :uri
        def code 
          attributes[:code]
        end

        def code=(val) 
          attributes[:code] = val
        end

        def icon 
          attributes[:icon]
        end

        def icon=(val) 
          attributes[:icon] = val
        end

        def location_name 
          attributes[:locationName]
        end

        def location_name=(val) 
          attributes[:locationName] = val
        end

        def location_uri 
          attributes[:locationUri]
        end

        def location_uri=(val) 
          if val
            attributes[:locationUri] = UU::OS::UESURI.new(val)
          else
            attributes[:locationUri] = nil
          end
        end

        def name 
          attributes[:name]
        end

        def name=(val) 
          attributes[:name] = val
        end

        def organizational_unit_name 
          attributes[:organizationalUnitName]
        end

        def organizational_unit_name=(val) 
          attributes[:organizationalUnitName] = val
        end

        def organizational_unit_uri 
          attributes[:organizationalUnitUri]
        end

        def organizational_unit_uri=(val) 
          if val
            attributes[:organizationalUnitUri] = UU::OS::UESURI.new(val)
          else
            attributes[:organizationalUnitUri] = nil
          end
        end

        def state_icon 
          attributes[:stateIcon]
        end

        def state_icon=(val) 
          attributes[:stateIcon] = val
        end

        def state_type 
          attributes[:stateType]
        end

        def state_type=(val) 
          attributes[:stateType] = val
        end

        def uri 
          attributes[:uri]
        end

        def uri=(val) 
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

      end
    end

  end
end
