require 'uu/os/rest/dto'

module UU
  module OS
    module Sheet
      class SheetCheckOut < UU::OS::REST::DTO

        # A flag that indicates whether the instance is mutable or not. @exclud
        attr_accessor :immutable

        # Specifies when return stream. Null means only lock sheet and don't return any stream.
        attr_accessor :return_stream_handler

        # Specifies whether to lock sheet only or to lock and return data . Null means that
        # the sheet is locked and return data.
        attr_accessor :lock_only

        # Type of the content.
        attr_accessor :required_mime_type
        def immutable 
          attributes[:immutable]
        end

        def immutable=(val) 
          attributes[:immutable] = val
        end

        def return_stream_handler 
          attributes[:returnStreamHandler]
        end

        def return_stream_handler=(val) 
          attributes[:returnStreamHandler] = val
        end

        def lock_only 
          attributes[:lockOnly]
        end

        def lock_only=(val) 
          attributes[:lockOnly] = val
        end

        def required_mime_type 
          attributes[:requiredMimeType]
        end

        def required_mime_type=(val) 
          attributes[:requiredMimeType] = val
        end

      end
    end

  end
end
