require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS

    module Shortcut
      class ShortcutAttributes < UU::OS::REST::DTO

        # Normalized UESURI of the shortcut. Never nil.
        attr_accessor :uri

        # Name of the shortcut. Never nil.
        attr_accessor :name

        # Code of the shortcut. Never nil.
        attr_accessor :code

        # Description of the shortcut. Never nil.
        attr_accessor :description

        # UESURI of the referenced artifact. Never nil.
        attr_accessor :artifact_uri

        # Version of the shortcut.
        attr_accessor :version

        # UESURI of the entity type of the shortcut. Never nil.
        attr_accessor :entity_type_uri

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def artifact_uri
          attributes[:artifactUri]
        end

        def artifact_uri=(val)
          if val
            attributes[:artifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:artifactUri] = nil
          end
        end

        def version 
          attributes[:version]
        end

        def version=(val) 
          attributes[:version] = val
        end

        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end

  end

end
